/*--------------------------------------*/
/* SSIM ZovO              */
/* 	(c) tkimura                         */
/*                                      */
/*  Initial     2024/12/02   T.Kimura   */
/*                                      */
/*--------------------------------------*/
/*------------------------------------------------------------------*/
/* SSIM vZ Web TCg												*/
/*																	*/
/* https://darosh.github.io/image-ssim-js/test/browser_test.html	*/
/*																	*/
/*------------------------------------------------------------------*/
/* SSIM ͉摜ŜŌvẐł͂ȂC̈斈ɌvZČŕ	*/
/* DMATLAB LTCgƋ߂lɂȂ̂őD			*/
/* ̈̃TCY MATLAB ł default 8 炵̂ŁC8 ɂĂ	*/
/*------------------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "image.h"

/* --- */
#define		DEBUG		0	/* ʓI DEBUG p */
#define		IMG_DEBUG	0	/* ǂݍ񂾉摜{ɖ肪ǂmF */

#define 	WINDOWS_SIZE 8	/* SSIM ͏̈斈ɌvZ */

/* vg^Cv錾 */
double calculate_ssim( ImageData *img1, ImageData *img2, int in_x, int in_y );

/*----------------------*/
/* Main Routine         */
/*----------------------*/
int main( int argv, char *argc[] ) 
{
    int width = 512, height = 512;
	int x, y, loc, res;
    Pixel pix;

	/* BMP File ǂݍݗp */
    ImageData *img1/*Ǎ摜P*/, *img2/*Ǎ摜Q*/;
  #if IMG_DEBUG
    Pixel pix_test;
    ImageData *img3/*Testp*/;
  #endif

	double ssim_value;
	
	//------------------------------
    // img1img2̃f[^ǂݍ
	//------------------------------
    /* ꍇ */
    if( argv < 3 ) {
        printf("p[^܂\n");
        printf("ssim_calc <read image file(1) name> <read image file(2) name>\n");
        return 1;
    }

    // t@C摜f[^P̓ǂݍ
    res = readBMPfile( argc[1]/*read image*/, &img1);
    if( res<0 ) {
        printf("͂P̉摜f[^ǂ߂܂");
        return 1;
    }

    // t@C摜f[^Q̓ǂݍ
    res = readBMPfile( argc[2]/*read image*/, &img2);
    if( res<0 ) {
        printf("͂Q̉摜f[^ǂ߂܂");
        return 1;
    }

	/* 摜̓mN̂ݑΉ */
	if( (img1->depth != 8) || (img2->depth != 8) ) {
		printf("̃vO̓mN̂ݑΉĂ܂\n");
		return 1;
	}

	/* ͂Q̉摜̃TCYǂmF */
	if( (img1->height != img2->height) || (img1->width != img2->width) ) {
		printf("Q̉摜̃TCY܂DTCỶ摜gĉ\n");
		printf("(1)H:%d, W:%d <=> (2)H:%d, W:%d\n", img1->height, img1->width, img2->height, img2->width);
		return 1;
	}
	
	if( (img1->height % WINDOWS_SIZE) || (img1->width % WINDOWS_SIZE) ) {
		printf("摜̃TCŸTCY %d Ŋ؂܂(H:%d, W:%d)\n", WINDOWS_SIZE, img1->height, img1->width);
		return 1;
	}

  #if IMG_DEBUG
    // i[p摜f[^쐬
    img3 = createImage(img1->width,img1->height, img1->depth);
  #endif

	/* SSIM ̎Zo(̈斈ɌvZāCŕωĂ) */
	ssim_value = 0.0;
	for( y = 0 ; y <= (img1->height - WINDOWS_SIZE - 1) ; y += WINDOWS_SIZE ) {
		for( x = 0 ; x <= (img1->width - WINDOWS_SIZE - 1) ; x += WINDOWS_SIZE ) {
		    ssim_value += calculate_ssim( img1, img2, x, y );
		}
	}
	ssim_value = ssim_value / ((img1->height / WINDOWS_SIZE) * (img1->width / WINDOWS_SIZE));

    printf("SSIM: %f\n", ssim_value);

  #if IMG_DEBUG
    writeBMPfile( "write_test.bmp"/*write image*/, img3);
  #endif

    disposeImage(img1);
    disposeImage(img2);
  #if IMG_DEBUG
    disposeImage(img3);
  #endif
    return 0;
}

/*--------------------------------------*/
/* SSIM Zo[`(̈ł̎Zo)    */
/*--------------------------------------*/
double calculate_ssim( ImageData *img1, ImageData *img2, int in_x, int in_y ) 
{
    double C1 = 6.5025, C2 = 58.5225;	/* Default l */

    double mean1 = 0.0, mean2 = 0.0;
    double var1 = 0.0, var2 = 0.0;
    double cov = 0.0;
    double ssim;

	Pixel pix1, pix2;
    int x, y, size;

	size = WINDOWS_SIZE * WINDOWS_SIZE;
  #if DEBUG
	printf("H:%d, W:%d size:%d\n", img1->height, img1->width, size );
  #endif

	/* ϒľvZ */
    for ( y = in_y; y < (in_y + WINDOWS_SIZE) ; y++ ) {
	    for ( x = in_x; x < (in_x + WINDOWS_SIZE) ; x++ ) {
    	    getPixel(img1, x, y, &pix1);
   	     	mean1 += (double)pix1.r;

    	    getPixel(img2, x, y, &pix2);
   	     	mean2 += (double)pix2.r;
		}
    }
    mean1 /= size;
    mean2 /= size;

  #if DEBUG
	printf("y(1)=%d, x(1)=%d\n", y, x);
  #endif
	/* UľvZ */
    for ( y = in_y; y < (in_y + WINDOWS_SIZE) ; y++ ) {
	    for ( x = in_x; x < (in_x + WINDOWS_SIZE) ; x++ ) {
	   	    getPixel(img1, x, y, &pix1);
	        var1 += (pix1.r - mean1) * (pix1.r - mean1);

	   	    getPixel(img2, x, y, &pix2);
        	var2 += (pix2.r - mean2) * (pix2.r - mean2);

	        cov += (pix1.r - mean1) * (pix2.r - mean2);		/* ǓvZ */
		}
    }
  #if DEBUG
	printf("y(2)=%d, x(2)=%d\n", y, x);
  #endif

    var1 /= (size/*width * height*/ - 1);
    var2 /= (size/*width * height*/ - 1);
    cov /= (size/*width * height*/ - 1);

    ssim = (2 * mean1 * mean2 + C1) * (2 * cov + C2)
           / ((mean1 * mean1 + mean2 * mean2 + C1) * (var1 + var2 + C2));

    return ssim;
}

